var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.cleanNodeModules=exports.installPackageDependencies=exports.checkIfProjectAndNodeModulesExists=exports.listAndSelectNpmVersion=void 0;var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _semver=_interopRequireDefault(require("semver"));
var _path=_interopRequireDefault(require("path"));
var _inquirer=_interopRequireDefault(require("inquirer"));
var _exec=require("./exec");
var _fileutils=require("./fileutils");
var _logger=require("./logger");
var _constants=require("../constants");
var _resolve=require("../resolve");


var _prompt=require("../../cli/prompt");

var listAndSelectNpmVersion=function listAndSelectNpmVersion(c,npmPackage){var templateVersionsStr,versionArr,rnvVersion,validVersions,_await$inquirer$promp,inputTemplateVersion;return _regenerator.default.async(function listAndSelectNpmVersion$(_context){while(1){switch(_context.prev=_context.next){case 0:_context.next=2;return _regenerator.default.awrap(
(0,_exec.executeAsync)(
c,"npm view "+
npmPackage+" versions"));case 2:templateVersionsStr=_context.sent;

versionArr=templateVersionsStr.
replace(/\r?\n|\r|\s|'|\[|\]/g,'').
split(',').
reverse();
rnvVersion=c.rnvVersion;


validVersions=versionArr.
filter(function(version){return _semver.default.lte(version,rnvVersion);}).
map(function(v){return{name:v,value:v};});
if(validVersions[0].name===rnvVersion){

validVersions[0].name=validVersions[0].name+" (recommended)";
}_context.next=9;return _regenerator.default.awrap(

_inquirer.default.prompt({
name:'inputTemplateVersion',
type:'list',
message:"What "+npmPackage+" version to use?",
default:versionArr[0],
choices:validVersions}));case 9:_await$inquirer$promp=_context.sent;inputTemplateVersion=_await$inquirer$promp.inputTemplateVersion;return _context.abrupt("return",


inputTemplateVersion);case 12:case"end":return _context.stop();}}},null,null,null,Promise);};exports.listAndSelectNpmVersion=listAndSelectNpmVersion;


var checkIfProjectAndNodeModulesExists=function checkIfProjectAndNodeModulesExists(c){return _regenerator.default.async(function checkIfProjectAndNodeModulesExists$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
(0,_logger.logTask)('checkIfProjectAndNodeModulesExists');if(!(

c.paths.project.configExists&&!(0,_fileutils.fsExistsSync)(c.paths.project.nodeModulesDir))){_context2.next=6;break;}
c._requiresNpmInstall=false;
(0,_logger.logWarning)(
'Looks like your node_modules folder is missing. INSTALLING...');_context2.next=6;return _regenerator.default.awrap(

installPackageDependencies(c));case 6:case"end":return _context2.stop();}}},null,null,null,Promise);};exports.checkIfProjectAndNodeModulesExists=checkIfProjectAndNodeModulesExists;



var installPackageDependencies=function installPackageDependencies(c){var _c$buildConfig,_c$buildConfig$tasks,_c$buildConfig$tasks$;var failOnError,skipJetifier,customScript,isYarnInstalled,yarnLockPath,npmLockPath,command,_await$inquirerPrompt,packageManager,_c$files$project$conf,_c$files$project$conf2,plats,_args3=arguments;return _regenerator.default.async(function installPackageDependencies$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:failOnError=_args3.length>1&&_args3[1]!==undefined?_args3[1]:false;skipJetifier=_args3.length>2&&_args3[2]!==undefined?_args3[2]:false;
customScript=(_c$buildConfig=c.buildConfig)==null?void 0:(_c$buildConfig$tasks=_c$buildConfig.tasks)==null?void 0:(_c$buildConfig$tasks$=_c$buildConfig$tasks.install)==null?void 0:_c$buildConfig$tasks$.script;if(!

customScript){_context3.next=9;break;}
(0,_logger.logTask)('installPackageDependencies');
(0,_logger.logInfo)("Found custom task for install: "+customScript+".");_context3.next=8;return _regenerator.default.awrap(
(0,_exec.executeAsync)(customScript));case 8:return _context3.abrupt("return",
true);case 9:


isYarnInstalled=(0,_exec.commandExistsSync)('yarn')||(0,_resolve.doResolve)('yarn',false);
yarnLockPath=_path.default.join(c.paths.project.dir,'yarn.lock');
npmLockPath=_path.default.join(c.paths.project.dir,'package-lock.json');
command='npm install';if(!
(0,_fileutils.fsExistsSync)(yarnLockPath)){_context3.next=17;break;}
command='yarn';_context3.next=27;break;case 17:if(!
(0,_fileutils.fsExistsSync)(npmLockPath)){_context3.next=21;break;}
command='npm install';_context3.next=27;break;case 21:if(!
isYarnInstalled){_context3.next=27;break;}_context3.next=24;return _regenerator.default.awrap(
(0,_prompt.inquirerPrompt)({
type:'list',
name:'packageManager',
message:'What package manager would you like to use?',
choices:['yarn','npm'],
default:'npm'}));case 24:_await$inquirerPrompt=_context3.sent;packageManager=_await$inquirerPrompt.packageManager;

if(packageManager==='yarn')command='yarn';case 27:

(0,_logger.logTask)('installPackageDependencies',"packageManager:("+command+")");_context3.prev=28;_context3.next=31;return _regenerator.default.awrap(


(0,_exec.executeAsync)(command));case 31:_context3.next=33;return _regenerator.default.awrap(
(0,_fileutils.invalidatePodsChecksum)(c));case 33:_context3.next=52;break;case 35:_context3.prev=35;_context3.t0=_context3["catch"](28);if(!

failOnError){_context3.next=40;break;}
(0,_logger.logError)(_context3.t0);return _context3.abrupt("return",
false);case 40:

(0,_logger.logWarning)(_context3.t0+"\n Seems like your node_modules is corrupted by other libs. ReNative will try to fix it for you");_context3.prev=41;_context3.next=44;return _regenerator.default.awrap(



cleanNodeModules(c));case 44:_context3.next=46;return _regenerator.default.awrap(
installPackageDependencies(c,true));case 46:_context3.next=52;break;case 48:_context3.prev=48;_context3.t1=_context3["catch"](41);

(0,_logger.logError)(_context3.t1);return _context3.abrupt("return",
false);case 52:_context3.prev=52;



plats=(_c$files$project$conf=c.files.project.config)==null?void 0:(_c$files$project$conf2=_c$files$project$conf.defaults)==null?void 0:_c$files$project$conf2.supportedPlatforms;if(!(

Array.isArray(plats)&&(plats.includes(_constants.ANDROID)||
plats.includes(_constants.ANDROID_TV)||plats.includes(_constants.ANDROID_WEAR)))){_context3.next=58;break;}if(!(

!skipJetifier&&(0,_resolve.doResolve)('jetifier'))){_context3.next=58;break;}_context3.next=58;return _regenerator.default.awrap(
(0,_exec.executeAsync)('npx jetify'));case 58:return _context3.abrupt("return",


true);case 61:_context3.prev=61;_context3.t2=_context3["catch"](52);

(0,_logger.logError)(_context3.t2);return _context3.abrupt("return",
false);case 65:case"end":return _context3.stop();}}},null,null,[[28,35],[41,48],[52,61]],Promise);};exports.installPackageDependencies=installPackageDependencies;



var cleanNodeModules=function cleanNodeModules(){return new Promise(function(resolve,reject){
(0,_logger.logTask)('cleanNodeModules');
var dirs=[
'react-native-safe-area-view/.git',
'@react-navigation/native/node_modules/react-native-safe-area-view/.git',
'react-navigation/node_modules/react-native-safe-area-view/.git',
'react-native-safe-area-view/.git',
'@react-navigation/native/node_modules/react-native-safe-area-view/.git',
'react-navigation/node_modules/react-native-safe-area-view/.git'].
reduce(function(acc,dir){var _dir$match=
dir.match(/([^/]+)\/(.*)/),_dir$match2=(0,_slicedToArray2.default)(_dir$match,3),_all=_dir$match2[0],aPackage=_dir$match2[1],aPath=_dir$match2[2];
(0,_logger.logDebug)("Cleaning: "+_all);
var resolved=(0,_resolve.doResolve)(aPackage,false);
if(resolved){
acc.push(resolved+"/"+aPath);
}
return acc;
},[]);
(0,_fileutils.removeDirs)(dirs).
then(function(){return resolve();}).
catch(function(e){return reject(e);});








});};exports.cleanNodeModules=cleanNodeModules;
//# sourceMappingURL=npmUtils.js.map